// EWCLIB [Easy Web Camera LIBrary]
//           version 2.8
// Copyright (C) 2018-2021 I.N.  All rights reserved.

// OS:Windows XP/Vista/7/8/8.1/10
// Compiler:Visual C++ 2008, 2010~2019+[qedit.h]

// 2010/04/15 ver.1.9 EWC_GetLastMessage():Unicode/}`oCg̗Ή
// 2010/05/04         Jn
// 2010/05/06         EWC_Open()/EWC_Close()dlύXD
// 2010/05/06         EWC_Run()/EWC_Stop()ǉD
// 2010/05/08         EWC_CloseAll()ǉD
// 2010/05/13 ver.2.0 
// 2012/02/28 ver.2.1 ̃[NC
// 2014/01            őJύX(8->10), @device:swΏۂƂ
// 2014/01            foCXgpς݃tO,EWC_GetFormat()ǉ
// 2014/01            EWC_Open():FriendlyNamew,ftHglǉ
// 2014/01/17 ver.2.2 EWC_Open()̃oG[Vǉ,EWC_GetDeviceName()ǉ
// 2014/01/27         foCXo̓s̃tH[}bgw̋@\ǉ
// 2014/01/27         tH[}bgꗗ擾Tv̏C
// 2014/01/27         EWC_Open()ǉ,ewc_type,ewc_device_type(EWC_DEVICE_TYPE)ǉ
// 2014/01/27 ver.2.3 EWC_GetDeviceSubtype(),EWC_GetSubtype(),EWC_GUIDtoTEXT()ǉ
// 2014/04/08         ewc_s[].countǉ,EWC_Pause()ǉ,EWC_OneShot()ǉ
// 2014/04/22 ver.2.4 EWC_SaveProperty(),EWC_LoadProperty(),EWC_SetManual()ǉ
// 2018/05/29 ver.2.5 Visual C++ 2017Ή
// 2020.06.26 ver.2.6 EWC_IsCaptured(),EWC_GetImage()̎dlύXCOobt@@\̒ǉ
// 2021.03.30         EWC_GUIDtoTEXT()ɃtH[}bgǉ
// 2021.04.16         ewc_raw̒ǉDEWC_CnvNV12toRGB32()̒ǉD
// 2021.04.16         EWC_PropertyPage()̃Xbh
// 2021.04.19         EWC_GetCamera()Ɨ, EWC_GetCameraName(), struct ewc_cameraǉ
// 2021.04.20 ver.2.7 EWC_CnvY16toRGB32(), EWC_CnvY800toRGB32()̒ǉ
// 2021.04.25 ver.2.7b EWC_SetBuffer()EWC_GetImage()̑Qȗ(܂NULL)Ŏgp
// 2021.05.13         ̃f[^TCY擾邽EWC_IsCaptured()̈dlύX
// 2021.05.13         EWC_BufferLock(),EWC_BufferUnlock()̒ǉ
// 2021.05.13         obt@2ȏ̂Ƃ1̃TCYRGB32Ƃ
// 2021.05.17         EWC_GetImage()̈dlύXCEWC_IsCaptured()ɂׂďW
// 2021.05.21 ver.2.8 ewc_rawp~DEWC_RawMode()ǉD

#pragma once
#define EWCLIB_H

#include <math.h>		//for floor()
#include <dshow.h>
#pragma include_alias( "dxtrans.h", "qedit.h" )
#define __IDxtCompositor_INTERFACE_DEFINED__
#define __IDxtAlphaSetter_INTERFACE_DEFINED__
#define __IDxtJpeg_INTERFACE_DEFINED__
#define __IDxtKey_INTERFACE_DEFINED__
#include <qedit.h>
#pragma comment(lib,"strmiids.lib")
#pragma comment(lib,"Quartz.lib")

//摜tH[}bgio͕j
#ifndef EWC_TYPE
	#ifdef _CV_H_
		#define EWC_TYPE MEDIASUBTYPE_RGB24
	#else
		#ifdef __OPENCV_CV_H__
			#define EWC_TYPE MEDIASUBTYPE_RGB24
		#else
			#define EWC_TYPE MEDIASUBTYPE_RGB32
		#endif
	#endif
#endif
//ftHgl
GUID ewc_type= EWC_TYPE;

//摜tH[}bgifoCXo̓sj
#ifndef EWC_DEVICE_TYPE
	#define EWC_DEVICE_TYPE GUID_NULL
#endif
//ftHgl
GUID ewc_device_type= EWC_DEVICE_TYPE;

#ifndef EWC_WX
	#define EWC_WX 640
#endif
#ifndef EWC_WY
	#define EWC_WY 480
#endif
#ifndef EWC_FPS
	#define EWC_FPS 30
#endif
//ftHgl
int ewc_wx= EWC_WX;
int ewc_wy= EWC_WY;
double ewc_fps= EWC_FPS;

#ifndef min
	#define min(a,b) ((a)<(b)?(a):(b))
#endif
#ifndef max
	#define max(a,b) ((a)>(b)?(a):(b))
#endif
// macro:Limit()  ... example Limit(0,Red,255);
#ifndef Limit
	#define Limit(a,b,c) min(max((a),(b)),(c))
#endif

#ifndef EWC_NCAMMAX
#define EWC_NCAMMAX 10	//J̍őFv2.2
#endif

#ifndef EWC_BUF_NUM
#define EWC_BUF_NUM	 1	//Oobt@i1ȏ̐jv2.6
#endif
HANDLE ewc_hmutex[EWC_NCAMMAX];			//Mutex̃nh
//Mutex
#define ewc_mget(n)		WaitForSingleObject(ewc_hmutex[(n)],INFINITE)
#define ewc_mrls(n)		ReleaseMutex(ewc_hmutex[(n)])

int ewc_cominit= 0;			//COMtO(1ȂIs)
int ewc_ncam= -1;			//Jڑ
int ewc_order[EWC_NCAMMAX];	//ԍ̏
int ewc_ordercnt= 0;		//ewc_order[]̂߂̃JE^
HRESULT ewc_hr;
int ewc_used[EWC_NCAMMAX];	//foCXgpς݃tO
int ewc_raw[EWC_NCAMMAX];	//̂܂ܓ]Ȃ1 (v2.8)

#define EWC_RUN_TIMEOUT		3000
#define EWC_STOP_TIMEOUT	3000
#define EWC_RETRYTIMES		3

#define EWC_VPAMPMAX	10
#define EWC_CAMCTLMAX	7
#define EWC_ITEMMAX		(EWC_VPAMPMAX+EWC_CAMCTLMAX)

#define ewc_release(x) {if(x)x->Release();x=0;}

//\̂̒`
struct ewc_struct{
	int wx;					//摜̕
	int wy;					//摜̍
	double fps;				//t[[giwlj
	int device;				//foCXԍiwlj
	int devn;				//蓖ĂꂽfoCXԍv2.2
	char *pdname;			//FriendlyNamerpv2.2
	char dname[256];		//擾FriendlyName v2.2
	GUID mstype;			//o͉摜̃tH[}bg
	char mstype_t[80];		//mstypeɑΉ镶v2.3
	GUID dev_mstype;		//foCXo̓s̃tH[}bgv2.3
	char dev_mstype_t[80];	//dev_mstypeɑΉ镶v2.3
	HANDLE hThread;			//PropertyPageXbh̃nhv2.7
	int ppnum;				//PropertyPageXbh֓nlv2.7
	volatile int init;
	volatile int stop;
	volatile int errcode;
	BYTE *pbuf;				//摜̕ۑiOobt@̐擪j
	BYTE *buffer;			//ŊmۂOobt@̐擪
	double ftime;			//t[(s)̎liŐVlj
	int w_count;			//writeJE^lv2.6
	int r_count;			//readJE^lv2.6
	int buffer_r;			//obt@̑I(read)v2.6
	int buffer_w;			//obt@̑I(write)v2.6
	double buf_stime[EWC_BUF_NUM];	//eobt@̃Tv(s)v2.6
	int buf_count[EWC_BUF_NUM];		//eobt@̃JE^lv2.6
	long bufsize[EWC_BUF_NUM];		//ꂽeTṽoCgv2.8
	long bufsize32;					//RGB32̃oCgĩTCYŃOobt@mہjv2.8
	BYTE *pbufadr[EWC_BUF_NUM];		//eTv̐擪AhXv2.8
	int vflag[EWC_ITEMMAX];
	IGraphBuilder *pGraph;
	IBaseFilter *pF;
	ISampleGrabber *pGrab;
	ICaptureGraphBuilder2 *pBuilder;
	IBaseFilter *pCap;
	IAMVideoProcAmp *pVPAmp;
	IAMCameraControl *pCamCtl;
	IMediaControl *pMediaControl;
	IAMStreamConfig *pConfig;
	IMoniker *pMoniker;
	IEnumMoniker *pEnum;
	ICreateDevEnum *pDevEnum;
	AM_MEDIA_TYPE *pmt;
	AM_MEDIA_TYPE mt;
	IPin *pSrcOut;
	IPin *pSGrabIn;
	IMediaEvent *pMediaEvent;
};

ewc_struct ewc_s[EWC_NCAMMAX];

//tH[}bgi[̂߂̍\v2.3
struct ewc_format{
	int width;
	int height;
	int bit;
	REFERENCE_TIME AvgTimePerFrame;
	double fps;
	GUID subtype;
	char subtype_t[80];	//subtypeɑΉ镶v2.3
};

//i̎̃obt@ԍ𓾂
__inline int next_index(int i)
{
	return (i+1) % EWC_BUF_NUM;
}

//ȋÕobt@ԍ𓾂
__inline int prev_index(int i)
{
	return (i+EWC_BUF_NUM-1) % EWC_BUF_NUM;
}

//R[obN֐NX̒` v2.8
class ewc_SampleGrabberCB :public ISampleGrabberCB
{
public:
	STDMETHODIMP_(ULONG) AddRef()
	{
		return 2;
	}
	STDMETHODIMP_(ULONG) Release()
	{
		return 1;
	}
	STDMETHODIMP QueryInterface(REFIID riid, void ** ppv)
	{
		if(riid==IID_ISampleGrabberCB || riid==IID_IUnknown){
			*ppv= (void *)static_cast<ISampleGrabberCB*>(this);
			return NOERROR;
		}
		return E_NOINTERFACE;
	}
	STDMETHODIMP SampleCB(double SampleTime, IMediaSample *pSample)
	{
		return S_OK;
	}
	//t[̓ɌĂ΂R[obN֐
	STDMETHODIMP BufferCB(double dblSampleTime, BYTE *pBuffer, long lBufferSize)
	{
		ewc_mget(i);
		//buffer_w, buffer_r̍XV
		if(ewc_s[i].w_count==ewc_s[i].r_count){
			ewc_s[i].buffer_r= next_index(ewc_s[i].buffer_r);
			ewc_s[i].buffer_w= next_index(ewc_s[i].buffer_w);
		}else{
			ewc_s[i].buffer_w= next_index(ewc_s[i].buffer_w);
			if(ewc_s[i].buffer_w==ewc_s[i].buffer_r){
				ewc_s[i].buffer_r= next_index(ewc_s[i].buffer_r);
			}
		}
		int buf_w= ewc_s[i].buffer_w;		//ރOobt@ԍ
		BYTE *p0= ewc_s[i].pbuf + ewc_s[i].bufsize32 * buf_w;
		if(ewc_raw[i]){
			//̂܂܃Rs[(raw[h)
			memcpy(p0, pBuffer, lBufferSize);
		}else{
			//摜̏㉺tɂăRs[(RGB24,RGB32)
			int wx= ewc_s[i].wx;
			int wy= ewc_s[i].wy;
			int xbyte= lBufferSize/wy;	//PC̃oCg
			BYTE *src= pBuffer;
			BYTE *dst= p0 +xbyte*(wy-1);
			for(int y=0; y<wy; y++){
				memcpy(dst, src, xbyte);
				src += xbyte;
				dst -= xbyte;
			}
		}
		ewc_s[i].pbufadr[buf_w]= p0;											//f[^擪AhX
		ewc_s[i].bufsize[buf_w]= lBufferSize;									//f[^TCYi[
		ewc_s[i].ftime= dblSampleTime -ewc_s[i].buf_stime[prev_index(buf_w)];	//OƂ̎i[
		ewc_s[i].buf_stime[buf_w]= dblSampleTime;								//̎i[
		ewc_s[i].buf_count[buf_w]= ++ewc_s[i].w_count;							//t[ԍ̍XVƊi[
		ewc_mrls(i);
		return S_OK;
	}
	//RXgN^	
	ewc_SampleGrabberCB(int num)
	{
		i= num;
		ewc_s[i].pbuf= ewc_s[i].buffer;
		ewc_s[i].w_count= 0;
		ewc_s[i].r_count= 0;
		ewc_s[i].buffer_w= 0;
		ewc_s[i].buffer_r= 0;
		for(int i=0; i<EWC_BUF_NUM; i++){
			ewc_s[i].buf_stime[i]= 0.;
			ewc_s[i].buf_count[i]= 0;
			ewc_s[i].pbufadr[i]= NULL;
			ewc_s[i].bufsize[i]= 0;
		}
	}
	//fXgN^
	~ewc_SampleGrabberCB()
	{
	}
private:
	int i;
};

//R[obN֐
ewc_SampleGrabberCB *ewc_pSampleGrabberCB[EWC_NCAMMAX];

//Jԍ̃`FbN(߂lF0ȂJnum͗L)
int numCheck(int num)
{
	if(num<0 || num>=EWC_NCAMMAX) return 1;
	if(!ewc_s[num].init) return 2;
	return 0;
}

//obt@̃bN v2.8
int EWC_BufferLock(int num)
{
	if(numCheck(num)) return 1;
	ewc_mget(num);
	return 0;
}

//obt@̃bNƃOobt@Ǘ̍XV v2.8
int EWC_BufferUnlock(int num)
{
	if(numCheck(num)) return 1;
	int buf_r= ewc_s[num].buffer_r;
	ewc_s[num].r_count= ewc_s[num].buf_count[buf_r];
	if(buf_r != ewc_s[num].buffer_w) ewc_s[num].buffer_r= next_index(buf_r);
	ewc_mrls(num);
	return 0;
}

//IAMVideoProcAmp
#define EWC_BRIGHTNESS				0
#define EWC_CONTRAST				1
#define EWC_HUE						2
#define EWC_SATURATION				3
#define EWC_SHARPNESS				4
#define EWC_GAMMA					5
#define EWC_COLORENABLE				6
#define EWC_WHITEBALANCE			7
#define EWC_BACKLIGHTCOMPENSATION	8
#define EWC_GAIN					9
//IAMCameraControl
#define EWC_PAN						10
#define EWC_TILT					11
#define EWC_ROLL					12
#define EWC_ZOOM					13
#define EWC_EXPOSURE				14
#define EWC_IRIS					15
#define EWC_FOCUS					16

//ǂݏoׂ摜̃TCY(P:oCg)Ԃ v2.8
//EWC_IsCaptured()łTCY͕
int EWC_GetBufferSize(int num)
{
	if(numCheck(num)) return 0;
	ewc_mget(num);
	int buf_r= ewc_s[num].buffer_r;
	int size= ewc_s[num].bufsize[buf_r];
	ewc_mrls(num);
	return size;
}

//tB^̃s擾
IPin *ewc_GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir)
{
	IEnumPins *pEnum;
	IPin *pPin= NULL;

	ewc_hr= pFilter->EnumPins(&pEnum);
	if(ewc_hr!=S_OK) return NULL;

	while(pEnum->Next(1,&pPin,0)==S_OK){
		PIN_DIRECTION PinDirThis;
		pPin->QueryDirection(&PinDirThis);
		if(PinDir==PinDirThis) break;
		pPin->Release();
	}
	pEnum->Release();
	return pPin;
}

// V摜ǂ v2.8
//  num:Jԍ
//  buffer:ǂݏoׂ摜i[ĂAhXiIvVj
//  size:摜f[^̃TCY[PʁFoCg]iIvVj
//  frame:t[ԍiIvVj
//  buffer_r:ǂݏoOobt@̔ԍ(0`)iIvVj
//  stime:擾(b)iIvVj
// ߂l: Osȍ~ɓ摜i:0, ʏ:1, R}2ȏj
int EWC_IsCaptured(int num, BYTE **buffer=NULL, int *size=NULL, int *frame=NULL, int *buffer_r=NULL, double *stime=NULL)
{
	if(numCheck(num)) return 0;
	ewc_mget(num);
	int buf_r= ewc_s[num].buffer_r;
	int dif= ewc_s[num].buf_count[buf_r] -ewc_s[num].r_count;
	if(buffer) *buffer= ewc_s[num].pbufadr[buf_r];
	if(size) *size= ewc_s[num].bufsize[buf_r];
	if(frame) *frame= ewc_s[num].buf_count[buf_r];
	if(buffer_r) *buffer_r= ewc_s[num].buffer_r;
	if(stime) *stime= ewc_s[num].buf_stime[buf_r];
	ewc_mrls(num);
	return dif;
}

//J(ԍ:num)̉摜擾 v2.8
// num:Jԍ  buffer:摜f[^i[AhX(NULL͓]ȗ)
// lFEWC_SetBuffer()gĂƂ́C̊֐͎gȂ
int EWC_GetImage(int num, void *buffer)
{
	if(numCheck(num)) return 1;
	ewc_mget(num);
	int buf_r= ewc_s[num].buffer_r;
	if(buffer){
		void *src= (void *)ewc_s[num].pbufadr[buf_r];
		memcpy(buffer, src, ewc_s[num].bufsize[buf_r]);
	}
	ewc_s[num].r_count= ewc_s[num].buf_count[buf_r];
	if(buf_r != ewc_s[num].buffer_w) ewc_s[num].buffer_r= next_index(buf_r);
	ewc_mrls(num);
	return 0;
}

//obt@AhXύX
int EWC_SetBuffer(int num, void *buffer)
{
	if(numCheck(num)) return 1;
	ewc_mget(num);
	ewc_s[num].pbuf= (BYTE*)buffer;
	ewc_mrls(num);
	return 0;
}

//݂̃Oobt@擪AhX擾
int EWC_GetBuffer(int num, void **buffer)
{
	if(numCheck(num)) return 1;
	*buffer= ewc_s[num].pbuf;
	return 0;
}

//ݒlǂ񂾂菑肷֐ v2.4
int ewc_propfunc(int func, int num, int prop, double *value=NULL, int *mode=NULL)
{
	if(numCheck(num)) return 1;
	if(prop<0 || prop>=EWC_ITEMMAX) return 2;
	if(!ewc_s[num].vflag[prop]) return 3;

	long Min, Max, Step, Default, CapsFlags, Flags, Val;   

	if(prop<EWC_VPAMPMAX){
		//IAMVideoProcAmp̎擾 pVPAmp
		ewc_s[num].pCap->QueryInterface(IID_IAMVideoProcAmp,(void **)&ewc_s[num].pVPAmp);
		//IAMVideoProcAmp
		ewc_hr= ewc_s[num].pVPAmp->GetRange(prop,&Min,&Max,&Step,&Default,&CapsFlags);	//͈͂̎擾
		if(ewc_hr==S_OK){
			ewc_hr= ewc_s[num].pVPAmp->Get(prop,&Val,&Flags);	//ݒl̎擾

			switch(func){
				case 0:	//lɖ߂
					ewc_hr= ewc_s[num].pVPAmp->Set(prop,Default,Flags);
					break;
				case 1:	//lݒC蓮[h֐ؑ
					Val= (long)((*value*(Max-Min)/100.0)+Min);
					Val= min(max(Val,Min),Max);
					Val= (Val/Step)*Step;
					ewc_hr= ewc_s[num].pVPAmp->Set(prop,Val,VideoProcAmp_Flags_Manual);
					break;
				case 2:	//l̓ǂݏo
					*value= (Val-Min)*100.0/(double)(Max-Min);
					if(mode) if(Flags & VideoProcAmp_Flags_Auto) *mode=1; else *mode=0;
					break;
				case 3:	//蓮[hؑւ̂
					ewc_hr= ewc_s[num].pVPAmp->Set(prop,Val,VideoProcAmp_Flags_Manual);
					break;
				case 4:	//[hؑւ̂
					ewc_hr= ewc_s[num].pVPAmp->Set(prop,Val,VideoProcAmp_Flags_Auto);
					break;
			}
			ewc_release(ewc_s[num].pVPAmp);
			if(ewc_hr!=S_OK) return 5;
		}else{
			ewc_release(ewc_s[num].pVPAmp);
			return 4;
		}
	}else{
		//IAMCameraControl̎擾 pCamCtl
		ewc_s[num].pCap->QueryInterface(IID_IAMCameraControl,(void **)&ewc_s[num].pCamCtl);
		//IAMCameraControl
		prop -= EWC_VPAMPMAX;
		ewc_hr= ewc_s[num].pCamCtl->GetRange(prop,&Min,&Max,&Step,&Default,&CapsFlags);	//͈͂̎擾
		if(ewc_hr==S_OK){
			ewc_hr= ewc_s[num].pCamCtl->Get(prop,&Val,&Flags);	//ݒl̎擾

			switch(func){
				case 0:	//lɖ߂
					ewc_hr= ewc_s[num].pCamCtl->Set(prop,Default,Flags);
					break;
				case 1:	//lݒC蓮[h֐ؑ
					Val= (long)((*value*(Max-Min)/100.0)+Min);
					Val= min(max(Val,Min),Max);
					Val= (Val/Step)*Step;
					ewc_hr= ewc_s[num].pCamCtl->Set(prop,Val,CameraControl_Flags_Manual);
					break;
				case 2:	//l̓ǂݏo
					*value= (Val-Min)*100.0/(double)(Max-Min);
					if(mode) if(Flags & CameraControl_Flags_Auto) *mode=1; else *mode=0;
					break;
				case 3:	//蓮[hؑւ̂
					ewc_hr= ewc_s[num].pCamCtl->Set(prop,Val,CameraControl_Flags_Manual);
					break;
				case 4:	//[hؑւ̂
					ewc_hr= ewc_s[num].pCamCtl->Set(prop,Val,CameraControl_Flags_Auto);
					break;
			}
			ewc_release(ewc_s[num].pCamCtl);
			if(ewc_hr!=S_OK) return 5;
		}else{
			ewc_release(ewc_s[num].pCamCtl);
			return 4;
		}
	}
	return 0;
}

//ݒlǂݏo
//  IvVFmodeɂ0(manual)܂1(auto)i[
double EWC_GetValue(int num, int prop, int *mode=NULL)
{
	double v;
	if(mode) *mode=0;
	int r= ewc_propfunc(2, num, prop, &v, mode);
	if(r) return -1.0;
	else return v;
}

//蓮[hɐ؂ւ v2.4
int EWC_SetManual(int num, int prop)
{
	return ewc_propfunc(3, num, prop);
}

//ݒlύX(v2.4ewc_propfunc()Ăяo`ɕύX)
int EWC_SetValue(int num, int prop, double value)
{
	return ewc_propfunc(1, num, prop, &value);
}

//ݒlɖ߂(v2.4ewc_propfunc()Ăяo`ɕύX)
int EWC_SetDefault(int num, int prop)
{
	return ewc_propfunc(0, num, prop);
}

//[hɂ(v2.4ewc_propfunc()Ăяo`ɕύX)
int EWC_SetAuto(int num, int prop)
{
	return ewc_propfunc(4, num, prop);
}

//Ō̃G[bZ[W擾
//s:i[  size:̈s̃TCY
void EWC_GetLastMessage(char *s, int size)
{
	wchar_t w[MAX_ERROR_TEXT_LEN];
	AMGetErrorTextW(ewc_hr,w,MAX_ERROR_TEXT_LEN);	//1.9
	WideCharToMultiByte(CP_ACP,0,w,-1,s,size,NULL,NULL);
}

//Lv`̒~
int EWC_Stop(int num)
{
	if(numCheck(num)) return 1;

	//stop
	ewc_hr= ewc_s[num].pGraph->QueryInterface(IID_IMediaControl,(void **)&ewc_s[num].pMediaControl);
	if(ewc_hr==S_OK) ewc_s[num].pMediaControl->Stop(); else return 2;
	ewc_release(ewc_s[num].pMediaControl);

	long evCode;
	ewc_hr= ewc_s[num].pMediaEvent->WaitForCompletion(EWC_STOP_TIMEOUT,&evCode);
	if(ewc_hr!=S_OK){
		if(ewc_hr==E_ABORT) return 3;
	}
	return 0;
}

//Lv`̍ĊJ
int EWC_Run(int num)
{
	if(numCheck(num)) return 1;

	//run
	ewc_hr= ewc_s[num].pGraph->QueryInterface(IID_IMediaControl,(void **)&ewc_s[num].pMediaControl);
	if(ewc_hr==S_OK) ewc_hr= ewc_s[num].pMediaControl->Run(); else return 2;
	ewc_release(ewc_s[num].pMediaControl);

	long evCode;
	ewc_hr= ewc_s[num].pMediaEvent->WaitForCompletion(EWC_RUN_TIMEOUT,&evCode);
	if(ewc_hr!=S_OK){
		if(ewc_hr==E_ABORT) return 3;
	}
	return 0;
}

//Lv`Pause v2.4
int EWC_Pause(int num)
{
	if(numCheck(num)) return 1;

	//pause
	ewc_hr= ewc_s[num].pGraph->QueryInterface(IID_IMediaControl,(void **)&ewc_s[num].pMediaControl);
	if(ewc_hr==S_OK) ewc_hr= ewc_s[num].pMediaControl->Pause(); else return 2;
	ewc_release(ewc_s[num].pMediaControl);

	long evCode;
	ewc_hr= ewc_s[num].pMediaEvent->WaitForCompletion(EWC_RUN_TIMEOUT,&evCode);
	if(ewc_hr!=S_OK){
		if(ewc_hr==E_ABORT) return 3;
	}
	return 0;
}

//Vbg v2.4
int EWC_OneShot(int num)
{
	if(numCheck(num)) return 1;

	int c1,c2,c3;

	c1= ewc_s[num].w_count;
	EWC_Run(num);

	while((c2= ewc_s[num].w_count) == c1) Sleep(1);	//Pt[̂Ă
	while((c3= ewc_s[num].w_count) == c2) Sleep(1);
	EWC_Pause(num);

	return 0;
}

//vpeBy[W\i]Łj~v2.6
int EWC_PropertyPage1(int num)
{
	if(numCheck(num)) return 1;

	ISpecifyPropertyPages *pProp=0;

	ewc_hr= ewc_s[num].pCap->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
	if(ewc_hr!=S_OK) return 2;

	CAUUID caGUID;
	pProp->GetPages(&caGUID);
	ewc_release(pProp);

	FILTER_INFO FilterInfo;
	ewc_hr= ewc_s[num].pCap->QueryFilterInfo(&FilterInfo); 
	if(ewc_hr!=S_OK) return 3;

	IUnknown *pFilterUnk=0;
	ewc_hr= ewc_s[num].pCap->QueryInterface(IID_IUnknown,(void **)&pFilterUnk);
	if(ewc_hr!=S_OK){
		ewc_release(FilterInfo.pGraph);
		return 4;
	}

	OleCreatePropertyFrame(
		HWND_DESKTOP,		// Parent window(=NULL)
		0,0,				// Reserved
		FilterInfo.achName,	// Caption for the dialog box
		1,					// Number of objects (just the filter)
		&pFilterUnk,		// Array of object pointers. 
		caGUID.cElems,		// Number of property pages
		caGUID.pElems,		// Array of property page CLSIDs
		0,					// Locale identifier
		0, NULL				// Reserved
	);

	ewc_release(pFilterUnk);
	ewc_release(FilterInfo.pGraph);
	CoTaskMemFree(caGUID.pElems);
	return 0;
}

//vpeBy[WpXbh֐ v2.7
DWORD WINAPI ewc_PropertyPage_th(LPVOID lpParam)
{
	int num= *(int *)lpParam;
	int r= EWC_PropertyPage1(num);
	return r;
}

//vpeBy[W\(Xbhs) v2.7
int EWC_PropertyPage(int num)
{
	if(numCheck(num)) return 1;
	if(ewc_s[num].ppnum!=-1){	//ߋɊJꂽ`Ղ
		//Xbh͏IĂ邩
		DWORD status;
		if(GetExitCodeThread(ewc_s[num].hThread, &status)){
			if(status == STILL_ACTIVE){
				return 2;	//݊JĂ
			}else{
				CloseHandle(ewc_s[num].hThread);
				ewc_s[num].hThread= NULL;
				ewc_s[num].ppnum= -1;
			}
		}
	}

	ewc_s[num].ppnum= num;
	ewc_s[num].hThread= CreateThread(NULL,0,ewc_PropertyPage_th,&ewc_s[num].ppnum,0,NULL);
	if(ewc_s[num].hThread==NULL){
		ewc_s[num].ppnum= -1;
		return 3;
	}
	return 0;
}

//摜ϊ(32rbg->24rbg)
void EWC_Cnv32to24(unsigned char *dst, unsigned int *src, int pxl)
{
	unsigned char R,G,B;
	unsigned int ui;

	for(int n=0; n<pxl; n++){
		ui= *src++;
		B= ui;
		G= ui>>8;
		R= ui>>16;
		*(dst+0)= B;
		*(dst+1)= G;
		*(dst+2)= R;
		dst += 3;
	}
}

//摜ϊ(24rbg->32rbg)
void EWC_Cnv24to32(unsigned int *dst, unsigned char *src, int pxl)
{
	unsigned char R,G,B;

	for(int n=0; n<pxl; n++){
		B = *(src+0);
		G = *(src+1);
		R = *(src+2);
		src += 3;
		*dst++ = (R<<16) | (G<<8) | B;
	}
}

#ifndef INITGUID
#define INITGUID
#include <guiddef.h>
#undef INITGUID
#else 
#include <guiddef.h>
#endif
DEFINE_GUID(MEDIASUBTYPE_GREY, 0x59455247, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
DEFINE_GUID(MEDIASUBTYPE_Y8, 0x20203859, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
DEFINE_GUID(MEDIASUBTYPE_Y800, 0x30303859, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
DEFINE_GUID(MEDIASUBTYPE_Y16, 0x20363159, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xAA, 0x00, 0x38, 0x9B, 0x71);
DEFINE_GUID(MEDIASUBTYPE_BY8, 0x20385942, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);

#include <wmsdkidl.h>
#define EWC_MST_MAX 32
const struct {
	GUID guid;
	const char *s_mst;
} ewc_guid_mst[EWC_MST_MAX]= {
	{MEDIASUBTYPE_YUY2,  "YUY2"},
	{MEDIASUBTYPE_MJPG,  "MJPG"},
	{MEDIASUBTYPE_H264,  "H264"},
	{MEDIASUBTYPE_IYUV,  "IYUV"},
	{MEDIASUBTYPE_RGB24, "RGB24"},
	{MEDIASUBTYPE_RGB32, "RGB32"},
	{WMMEDIASUBTYPE_I420,"I420"},
	{MEDIASUBTYPE_RGB555,"RGB555"},
	{MEDIASUBTYPE_YV12,  "YV12"},
	{MEDIASUBTYPE_NV11,  "NV11"},
	{MEDIASUBTYPE_NV12,  "NV12"},
	{MEDIASUBTYPE_NV24,  "NV24"},
	{MEDIASUBTYPE_AYUV,  "AYUV"},
	{MEDIASUBTYPE_UYVY,  "UYVY"},
	{MEDIASUBTYPE_IMC1,  "IMC1"},
	{MEDIASUBTYPE_IMC2,  "IMC2"},
	{MEDIASUBTYPE_IMC3,  "IMC3"},
	{MEDIASUBTYPE_IMC4,  "IMC4"},
	{MEDIASUBTYPE_Y411,  "Y411"},
	{MEDIASUBTYPE_Y41P,  "Y41P"},
	{MEDIASUBTYPE_YVU9,  "YVU9"},
	{MEDIASUBTYPE_YVYU,  "YVYU"},
	{MEDIASUBTYPE_IF09,  "IF09"},
	{MEDIASUBTYPE_P010,  "P010"},
	{MEDIASUBTYPE_P016,  "P016"},
	{MEDIASUBTYPE_P210,  "P210"},
	{MEDIASUBTYPE_P216,  "P216"},
	{MEDIASUBTYPE_GREY,  "GREY"},
	{MEDIASUBTYPE_Y8,    "Y8"},
	{MEDIASUBTYPE_Y800,  "Y800"},
	{MEDIASUBTYPE_Y16,   "Y16"},
	{MEDIASUBTYPE_BY8,   "BY8"}
};

//fBATu^CvGUIDlɑΉ镶𐶐 v2.7
int EWC_GUIDtoTEXT(GUID guid, char *s, int size)
{
	for(int i=0; i<EWC_MST_MAX; i++){
		if(guid==ewc_guid_mst[i].guid){
			strcpy_s(s, size, ewc_guid_mst[i].s_mst);
			return 0;
		}
	}
	char ss[32];
	sprintf_s(ss,sizeof(ss),"%X",guid.Data1);
	strcpy_s(s,size,ss);
	return 1;
}

// v2.2
void ewc_freememory(int num)
{
	if(ewc_s[num].devn!=-1) ewc_used[ewc_s[num].devn]=0;	//v2.2
	ewc_release(ewc_s[num].pMediaEvent);
	ewc_release(ewc_s[num].pMediaControl);
	ewc_release(ewc_s[num].pCamCtl);
	ewc_release(ewc_s[num].pVPAmp);
	ewc_release(ewc_s[num].pGrab);
	ewc_release(ewc_s[num].pF);
	ewc_release(ewc_s[num].pBuilder);
	ewc_release(ewc_s[num].pCap);
	if(ewc_s[num].buffer){
		delete[] ewc_s[num].buffer;
		ewc_s[num].buffer= 0;
	}
	ewc_release(ewc_s[num].pGraph);
	if(ewc_pSampleGrabberCB[num]){	//v2.1
		delete ewc_pSampleGrabberCB[num];
		ewc_pSampleGrabberCB[num]= 0;
	}
}

//gpJn(EWC_Open()Ă΂) v2.3
void ewc_Open(int num)
{
	int errcode, retryflag, retrytime= EWC_RETRYTIMES;
	ewc_s[num].devn= -1;
	int t0= 0;
	VIDEOINFOHEADER *vh= NULL;
	int n= 0;		//foCX̃JEgp
	int regflag= 0;	//o^

    ewc_hmutex[num]= CreateMutex(NULL,FALSE,NULL);

cont:
	retryflag= 0;
	errcode= 0;

	//tB^Ot}l[W쐬 pGraph
	ewc_hr= CoCreateInstance(CLSID_FilterGraph,0,CLSCTX_INPROC_SERVER,IID_IGraphBuilder,(void **)&ewc_s[num].pGraph);
	if(ewc_hr!=S_OK){errcode=3; goto fin;}

	//VXefoCX񋓎q̍쐬
	ewc_hr= CoCreateInstance(CLSID_SystemDeviceEnum,0,CLSCTX_INPROC_SERVER,IID_ICreateDevEnum,(void **)&ewc_s[num].pDevEnum);
	if(ewc_hr!=S_OK){errcode=4; goto fin;}

	//񋓎q̎擾
	ewc_hr= ewc_s[num].pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,&ewc_s[num].pEnum,0);
	if(ewc_hr!=S_OK){
		//ESP_Printf("No driver\n");
		errcode=5; goto fin;
	}

	//jJ̎擾
	ULONG cFetched;
	wchar_t SrcName[32];

	for(int i=0; i<EWC_NCAMMAX; i++){
		if(ewc_s[num].pEnum->Next(1,&ewc_s[num].pMoniker,&cFetched)==S_OK){
			
			//DisplayName̎擾
			LPOLESTR strMonikerName=0;
			ewc_hr= ewc_s[num].pMoniker->GetDisplayName(NULL,NULL,&strMonikerName);
			if(ewc_hr!=S_OK){errcode=6; goto fin;}

			//char displayname[1024];
			//WideCharToMultiByte(CP_ACP,0,strMonikerName,-1,displayname,sizeof(displayname),0,0);
			//ESP_Printf("displayname(%d):%s\n",i,displayname);

			int cntflag= 0;		//foCXƂăJEgׂ
			if(wcsstr(strMonikerName,L"@device:pnp")!=NULL) cntflag= 1;	//DisplayName'@device:pnp'
			if(wcsstr(strMonikerName,L"@device:sw" )!=NULL) cntflag= 1;	//DisplayName'@device:sw'

			if(cntflag){
				char devname[256];	//FriendlyNamei[p

				//FriendlyName̎擾
				IPropertyBag *pBag= 0;
				ewc_s[num].pMoniker->BindToStorage(0,0,IID_IPropertyBag,(void **)&pBag);
				VARIANT var;
				VariantInit(&var);
				var.vt= VT_BSTR;
				pBag->Read(L"FriendlyName",&var,0);
				WideCharToMultiByte(CP_ACP,0,var.bstrVal,-1,devname,sizeof(devname),0,0);
				VariantClear(&var);
				ewc_release(pBag);

				int match= 0;	//o^ɍv
				if(ewc_s[num].pdname){
					//fCoXw̏ꍇ
					if(strstr(devname,ewc_s[num].pdname)) match=1;		//FriendlyNameƍ
				}else{
					//fCoXԍw܂͏ȗ
					if((ewc_s[num].device==-1) || (ewc_s[num].device!=-1 && n==ewc_s[num].device)) match=1;
				}
				//Γo^
				if(!regflag && !ewc_used[n] && match){
					//IuWFNg pCap
					ewc_s[num].pMoniker->BindToObject(0,0,IID_IBaseFilter,(void **)&ewc_s[num].pCap);
					//OtɃtB^ǉ
					swprintf_s(SrcName,32,L"Video Capture %d",num);
					ewc_hr= ewc_s[num].pGraph->AddFilter(ewc_s[num].pCap, SrcName);
					if(ewc_hr!=S_OK){errcode=7; goto fin;}
					regflag++;
					ewc_s[num].devn= n;
					strcpy_s(ewc_s[num].dname, sizeof(ewc_s[num].dname), devname);	//FriendlyNameۑ
					ewc_used[n]= 1;
				}
				n++;
			}
			ewc_release(ewc_s[num].pMoniker);
		}
	}

	if(ewc_ncam==-1) ewc_ncam= n;	//J̓o^

	ewc_release(ewc_s[num].pEnum);
	ewc_release(ewc_s[num].pDevEnum);

	if(!ewc_ncam){errcode=8; goto fin;}	//JȂ
	if(!regflag){errcode=9; goto fin;}	//o^̂Ȃ

	//Lv`r_̍쐬 pBuilder
	CoCreateInstance(CLSID_CaptureGraphBuilder2,0,CLSCTX_INPROC_SERVER,
		IID_ICaptureGraphBuilder2,(void **)&ewc_s[num].pBuilder);
	ewc_hr= ewc_s[num].pBuilder->SetFiltergraph(ewc_s[num].pGraph);
	if(ewc_hr!=S_OK){errcode=10; goto fin;}
	
	//IAMStreamConfigC^tF[X̎擾
	ewc_hr= ewc_s[num].pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE,&MEDIATYPE_Video,
		ewc_s[num].pCap,IID_IAMStreamConfig,(void**)&ewc_s[num].pConfig);
	if(ewc_hr!=S_OK){errcode=11; goto fin;}

	//摜TCYCt[[g̐ݒ
	ewc_hr= ewc_s[num].pConfig->GetFormat(&ewc_s[num].pmt);
	vh= (VIDEOINFOHEADER*)ewc_s[num].pmt->pbFormat;
	if(ewc_s[num].wx==0) ewc_s[num].wx= ewc_wx;		//ftHgl̓Kp
	if(ewc_s[num].wy==0) ewc_s[num].wy= ewc_wy;		//ftHgl̓Kp
	if(ewc_s[num].fps==0) ewc_s[num].fps= ewc_fps;	//ftHgl̓Kp
	ewc_wx= ewc_s[num].wx;		//ftHgl̍XV
	ewc_wy= ewc_s[num].wy;		//ftHgl̍XV
	ewc_fps= ewc_s[num].fps;	//ftHgl̍XV
	vh->bmiHeader.biWidth = ewc_s[num].wx;
	vh->bmiHeader.biHeight= ewc_s[num].wy; 
	vh->AvgTimePerFrame= (LONGLONG)floor((10000000.0/ewc_s[num].fps+0.5));

	//foCXo̓s̃tH[}bgwv2.3
	if(ewc_s[num].dev_mstype!=GUID_NULL){
		ewc_s[num].pmt->subtype= ewc_s[num].dev_mstype;
	}
	ewc_s[num].dev_mstype= ewc_s[num].pmt->subtype;
	//tH[}bgɑΉ镶̐ݒv2.3
	EWC_GUIDtoTEXT(ewc_s[num].mstype, ewc_s[num].mstype_t, sizeof(ewc_s[num].mstype_t));
	EWC_GUIDtoTEXT(ewc_s[num].dev_mstype, ewc_s[num].dev_mstype_t, sizeof(ewc_s[num].dev_mstype_t));

	ewc_hr= ewc_s[num].pConfig->SetFormat(ewc_s[num].pmt);
	if(ewc_hr!=S_OK){errcode=12; goto fin;}
	ewc_release(ewc_s[num].pConfig);

	//TvOo̐ pF,pGrab
	CoCreateInstance(CLSID_SampleGrabber,0,CLSCTX_INPROC_SERVER,IID_IBaseFilter,(LPVOID *)&ewc_s[num].pF);
	ewc_hr= ewc_s[num].pF->QueryInterface(IID_ISampleGrabber,(void **)&ewc_s[num].pGrab);
	if(ewc_hr!=S_OK){errcode=13; goto fin;}

	//fBA^Cv̐ݒ
	ZeroMemory(&ewc_s[num].mt,sizeof(AM_MEDIA_TYPE));
	ewc_s[num].mt.majortype= MEDIATYPE_Video;
	ewc_s[num].mt.subtype= ewc_s[num].mstype;
	ewc_type= ewc_s[num].mstype;	//ftHgl̍XV
	ewc_s[num].mt.formattype= FORMAT_VideoInfo;
	ewc_hr= ewc_s[num].pGrab->SetMediaType(&ewc_s[num].mt);
	if(ewc_hr!=S_OK){errcode=14; goto fin;}
	//tB^Otւ̒ǉ
	wchar_t GrabName[32];
	swprintf_s(GrabName,32,L"Grabber %d",num);
	ewc_hr= ewc_s[num].pGraph->AddFilter(ewc_s[num].pF, GrabName);
	if(ewc_hr!=S_OK){errcode=15; goto fin;}

	//TvOo̐ڑ
	// s̎擾
	ewc_s[num].pSrcOut= ewc_GetPin(ewc_s[num].pCap,PINDIR_OUTPUT);
	ewc_s[num].pSGrabIn= ewc_GetPin(ewc_s[num].pF,PINDIR_INPUT);
	// s̐ڑ
	ewc_hr= ewc_s[num].pGraph->Connect(ewc_s[num].pSrcOut, ewc_s[num].pSGrabIn);
	if(ewc_hr!=S_OK){errcode=16; goto fin;}

	ewc_release(ewc_s[num].pSrcOut);
	ewc_release(ewc_s[num].pSGrabIn);

	//Oõ[hݒ
	ewc_hr= ewc_s[num].pGrab->SetBufferSamples(FALSE);
	if(ewc_hr!=S_OK){errcode=17; goto fin;}
	ewc_hr= ewc_s[num].pGrab->SetOneShot(FALSE);
	if(ewc_hr!=S_OK){errcode=18; goto fin;}

	//Oobt@̊mہCR[obN֐̓o^
	//ibuffer32, buffer, ewc_pSampleGrabberCB[]̐ݒj
	//Oobt@͏RGB32̃TCYŁCCmۂ v2.8
	//ȉTCỸtH[}bgŎgpꍇCʂo邪CMJPĜ悤ɖω̂ɑΉ邽߁j
	ewc_s[num].bufsize32= sizeof(int) * ewc_s[num].wx * ewc_s[num].wy;
	ewc_s[num].buffer= new BYTE[ ewc_s[num].bufsize32 * EWC_BUF_NUM ];
	ewc_pSampleGrabberCB[num]= new ewc_SampleGrabberCB(num);
	ewc_hr= ewc_s[num].pGrab->SetCallback(ewc_pSampleGrabberCB[num],1);
	if(ewc_hr!=S_OK){errcode=19; goto fin;}

	//IAMVideoProcAmp̎擾 pVPAmp
	ewc_hr= ewc_s[num].pCap->QueryInterface(IID_IAMVideoProcAmp,(void **)&ewc_s[num].pVPAmp);
	if(ewc_hr!=S_OK){
		//IAMVideoProcAmp擾łȂ΁CT|[gĂȂƂ݂ȂD
		for(int j=0;j<EWC_VPAMPMAX;j++){
			//not supported
			ewc_s[num].vflag[j]= 0;
		}
	}else{
		for(int j=0;j<EWC_VPAMPMAX;j++){
			long Min, Max, Step, Default, Flags;   
			ewc_hr= ewc_s[num].pVPAmp->GetRange(j,&Min,&Max,&Step,&Default,&Flags);
			if(ewc_hr==S_OK){
				ewc_s[num].vflag[j]= 1;
			}else{
				//not supported
				ewc_s[num].vflag[j]= 0;
			}
		}
	}
	ewc_release(ewc_s[num].pVPAmp);

	//IAMCameraControl̎擾 pCamCtl
	ewc_hr= ewc_s[num].pCap->QueryInterface(IID_IAMCameraControl,(void **)&ewc_s[num].pCamCtl);
	if(ewc_hr!=S_OK){
		//IAMCameraControl擾łȂ΁CT|[gĂȂƂ݂ȂD
		for(int j=0;j<EWC_CAMCTLMAX;j++){
			//not supported
			ewc_s[num].vflag[j+EWC_VPAMPMAX]= 0;
		}
	}else{
		for(int j=0;j<EWC_CAMCTLMAX;j++){
			long Min, Max, Step, Default, Flags;   
			ewc_hr= ewc_s[num].pCamCtl->GetRange(j,&Min,&Max,&Step,&Default,&Flags);
			if(ewc_hr==S_OK){
				ewc_s[num].vflag[j+EWC_VPAMPMAX]= 1;
			}else{
				//not supported
				ewc_s[num].vflag[j+EWC_VPAMPMAX]= 0;
			}
		}
	}
	ewc_release(ewc_s[num].pCamCtl);

	//IMediaEvent̎擾 pMediaEvent
	ewc_hr= ewc_s[num].pGraph->QueryInterface(IID_IMediaEvent,(LPVOID *)&ewc_s[num].pMediaEvent);
	if(ewc_hr!=S_OK){errcode=20; goto fin;}

	//Lv`Jn pMediaControl
	ewc_hr= ewc_s[num].pGraph->QueryInterface(IID_IMediaControl,(void **)&ewc_s[num].pMediaControl);
	if(ewc_hr!=S_OK){errcode=21; goto fin;}
	ewc_hr= ewc_s[num].pMediaControl->Run();
	if(ewc_hr!=S_OK){errcode=22; retryflag=1; goto fin;}
	ewc_release(ewc_s[num].pMediaControl);

	//PȏTv܂őҋ@
	long evCode;
	ewc_s[num].pMediaEvent->WaitForCompletion(EWC_RUN_TIMEOUT,&evCode);
	if(ewc_hr!=S_OK){
		if(ewc_hr==E_ABORT){errcode=23; retryflag=1; goto fin;}
	}
	t0= GetTickCount();
	do{
		if((GetTickCount()-t0)>EWC_RUN_TIMEOUT){errcode=24; retryflag=1; goto fin;}
	}while(ewc_s[num].bufsize==0);

fin:
	if(errcode){
		//ESP_Printf("errcode=%d\n",errcode);
		ewc_release(ewc_s[num].pDevEnum);
		ewc_release(ewc_s[num].pEnum);
		ewc_release(ewc_s[num].pMoniker);
		ewc_release(ewc_s[num].pConfig);
		ewc_freememory(num);

		//ɐڑ܂ŃgC
		if(retryflag) if(--retrytime) goto cont;

		CloseHandle(ewc_hmutex[num]);
		ewc_s[num].ppnum= -1;
	}else{
		ewc_s[num].init= 1;
		ewc_order[ewc_ordercnt++]= num;
		ewc_s[num].ppnum= num;
	}

	ewc_s[num].errcode= errcode;
}

//EWC_Open()ōŏɌĂ΂Tu֐
void _ewc_open_pre(void)
{
	//COM̏
	if(!ewc_cominit && ewc_ncam==-1){
		ewc_hr= CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if(ewc_hr==S_OK) ewc_cominit=1;	//tO𗧂Ă
	}
	//\̂̏
	if(ewc_ncam==-1){
		for(int i=0; i<EWC_NCAMMAX; i++){
			ZeroMemory(&ewc_s[i],sizeof(ewc_struct));
		}
	}
}

//gpJn[1]ifoCXԍwjv2.3
int EWC_Open(int num, int wx=0, int wy=0, double fps=0, int device=-1, GUID mstype=ewc_type, GUID dev_mstype=ewc_device_type)
{
	if(num<0 || num>=EWC_NCAMMAX) return 1;

	_ewc_open_pre();

	if(ewc_s[num].init) return 2;

	ewc_s[num].wx= wx;
	ewc_s[num].wy= wy;
	ewc_s[num].fps= fps;
	ewc_s[num].device= device;
	ewc_s[num].pdname= NULL;
	ewc_s[num].mstype= mstype;
	ewc_s[num].dev_mstype= dev_mstype;
	ewc_s[num].errcode= -1;
	ewc_s[num].ppnum= -1;

	ewc_Open(num);

	return ewc_s[num].errcode;
}

//gpJn[2]ifoCXwjv2.3
int EWC_Open(int num, int wx, int wy, double fps, char *devicename, GUID mstype=ewc_type, GUID dev_mstype=ewc_device_type)
{
	if(num<0 || num>=EWC_NCAMMAX) return 1;

	_ewc_open_pre();

	if(ewc_s[num].init) return 2;

	ewc_s[num].wx= wx;
	ewc_s[num].wy= wy;
	ewc_s[num].fps= fps;
	ewc_s[num].device= -1;
	ewc_s[num].pdname= devicename;
	ewc_s[num].mstype= mstype;
	ewc_s[num].dev_mstype= dev_mstype;
	ewc_s[num].errcode= -1;
	ewc_s[num].ppnum= -1;

	ewc_Open(num);

	return ewc_s[num].errcode;
}

//gpJn[3]ifoCXwCwx/wy/fpsȗjv2.2
int EWC_Open(int num, char *devicename, GUID mstype=ewc_type, GUID dev_mstype=ewc_device_type)
{
	if(num<0 || num>=EWC_NCAMMAX) return 1;

	_ewc_open_pre();

	if(ewc_s[num].init) return 2;

	ewc_s[num].wx= 0;
	ewc_s[num].wy= 0;
	ewc_s[num].fps= 0;
	ewc_s[num].pdname= devicename;
	ewc_s[num].mstype= mstype;
	ewc_s[num].dev_mstype= dev_mstype;
	ewc_s[num].errcode= -1;
	ewc_s[num].ppnum= -1;

	ewc_Open(num);

	return ewc_s[num].errcode;
}

//I
int EWC_Close(int num)
{
	if(numCheck(num)) return 1;

	//Lv`~
	int r= EWC_Stop(num);
	if(r) return 2;

	//
	ewc_freememory(num);
	ewc_s[num].init= 0;

	if(ewc_ordercnt){
		if(ewc_order[ewc_ordercnt-1]==num){
			ewc_ordercnt--;
		}
	}

	//PropertyPagẽnhcĂI
	if(ewc_s[num].ppnum!=-1){	//ߋɊJꂽ`Ղ
		//Xbh͏IĂ邩
		DWORD status;
		if(GetExitCodeThread(ewc_s[num].hThread, &status)){
			if(status == STILL_ACTIVE){
				//݊JĂ
				TerminateThread(ewc_s[num].hThread, 0);
				WaitForSingleObject(ewc_s[num].hThread, 1000);
			}
			CloseHandle(ewc_s[num].hThread);
			ewc_s[num].hThread= NULL;
			ewc_s[num].ppnum= -1;
		}
	}

	//ׂďIȂCOMI
	int c=0;
	for(int i=0; i<EWC_NCAMMAX; i++){
		c += ewc_s[i].init;
	}
	if(c==0){
		if(ewc_cominit){
			CoUninitialize();
			ewc_cominit= 0;
		}
		ewc_ncam= -1;
	}

	CloseHandle(ewc_hmutex[num]);
	return 0;
}

//Iiׂāj
int EWC_CloseAll(void)
{
	int r=0;
	while(ewc_ordercnt>0){
		r += EWC_Close(ewc_order[--ewc_ordercnt]);
	}
	return r;
}

void ewc_FreeMediaType(AM_MEDIA_TYPE& mt)
{
	if(mt.cbFormat){
		CoTaskMemFree((PVOID)mt.pbFormat);
		mt.cbFormat= 0;
		mt.pbFormat= NULL;
	}
	if(mt.pUnk){
		ewc_release(mt.pUnk);
	}
}

void ewc_DeleteMediaType(AM_MEDIA_TYPE *pmt)
{
	if(pmt){
        ewc_FreeMediaType(*pmt); 
        CoTaskMemFree(pmt);
    }
}

//EWC_GetFormat()Ă΂
int ewc_GetFormat(int device, char *pdname, ewc_format *fmt, int *nmax)
{
	IGraphBuilder *pGraph= 0;
	ICreateDevEnum *pDevEnum= 0;
	IEnumMoniker *pEnum= 0;
	ICaptureGraphBuilder2 *pBuilder= 0;
	IBaseFilter *pCap= 0;
	IAMStreamConfig *pConfig= 0;
	IMoniker *pMoniker= 0;

	int ewc_cominit_gf= 0;
	int errcode= 0;

	int count= 0, size= 0;
	int m= 0;	//ŏIIȃtH[}bg
				
	int n= 0;		//foCX̃JEgp
	int regflag= 0;	//o^
	
	//COM̏
	if(!ewc_cominit){
		ewc_hr= CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if(ewc_hr==S_OK) ewc_cominit_gf= 1;	//tO𗧂Ă
	}

	//tB^Ot}l[W쐬 pGraph
	ewc_hr= CoCreateInstance(CLSID_FilterGraph,0,CLSCTX_INPROC_SERVER,IID_IGraphBuilder,(void **)&pGraph);
	if(ewc_hr!=S_OK){errcode=3; goto fin_gf;}

	//VXefoCX񋓎q̍쐬
	ewc_hr= CoCreateInstance(CLSID_SystemDeviceEnum,0,CLSCTX_INPROC_SERVER,IID_ICreateDevEnum,(void **)&pDevEnum);
	if(ewc_hr!=S_OK){errcode=4; goto fin_gf;}

	//񋓎q̎擾
	ewc_hr= pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,&pEnum,0);
	if(ewc_hr!=S_OK){errcode=5; goto fin_gf;}

	//jJ̎擾
	ULONG cFetched;
	wchar_t SrcName[32];

	for(int i=0; i<EWC_NCAMMAX; i++){
		if(pEnum->Next(1,&pMoniker,&cFetched)==S_OK){
			
			//DisplayName̎擾
			LPOLESTR strMonikerName=0;
			ewc_hr= pMoniker->GetDisplayName(NULL,NULL,&strMonikerName);
			if(ewc_hr!=S_OK){errcode=6; goto fin_gf;}

			int cntflag= 0;		//foCXƂăJEgׂ
			if(wcsstr(strMonikerName,L"@device:pnp")!=NULL) cntflag=1;	//DisplayName'@device:pnp'
			if(wcsstr(strMonikerName,L"@device:sw" )!=NULL) cntflag=1;	//DisplayName'@device:sw'

			if(cntflag){
				char devname[256];	//FriendlyNamei[p

				//FriendlyName̎擾
				IPropertyBag *pBag= 0;
				pMoniker->BindToStorage(0,0,IID_IPropertyBag,(void **)&pBag);
				VARIANT var;
				VariantInit(&var);
				var.vt= VT_BSTR;
				pBag->Read(L"FriendlyName",&var,0);
				WideCharToMultiByte(CP_ACP,0,var.bstrVal,-1,devname,sizeof(devname),0,0);
				VariantClear(&var);
				ewc_release(pBag);

				int match= 0;	//o^ɍv
				if(pdname){
					//fCoXw̏ꍇ
					if(strstr(devname,pdname)) match= 1;		//FriendlyNameƍ
				}else{
					//fCoXԍw܂͏ȗ
					if(n==device) match= 1;
				}
				//Γo^
				if(!regflag && match){
					//IuWFNg pCap
					pMoniker->BindToObject(0,0,IID_IBaseFilter,(void **)&pCap);
					//OtɃtB^ǉ
					swprintf_s(SrcName,32,L"Video Capture %d",i);
					ewc_hr= pGraph->AddFilter(pCap, SrcName);
					if(ewc_hr!=S_OK){errcode=7; goto fin_gf;}
					regflag++;
				}
				n++;
			}
			ewc_release(pMoniker);
		}
	}

	ewc_release(pEnum);
	ewc_release(pDevEnum);

	if(!regflag){errcode=9; goto fin_gf;}	//o^̂Ȃ

	//Lv`r_̍쐬 pBuilder
	CoCreateInstance(CLSID_CaptureGraphBuilder2,0,CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2,(void **)&pBuilder);
	ewc_hr= pBuilder->SetFiltergraph(pGraph);
	if(ewc_hr!=S_OK){errcode=10; goto fin_gf;}
	
	//IAMStreamConfigC^tF[X̎擾
	ewc_hr= pBuilder->FindInterface(&PIN_CATEGORY_CAPTURE,&MEDIATYPE_Video, pCap,IID_IAMStreamConfig,(void**)&pConfig);
	if(ewc_hr!=S_OK){errcode=11; goto fin_gf;}

	//-----̎擾-----
	ewc_hr= pConfig->GetNumberOfCapabilities(&count,&size);
	if(ewc_hr!=S_OK){errcode=12; goto fin_gf;}

	//ESP_Printf("count=%d\n",count);

	//-----tH[}bg̎擾-----
	if(size==sizeof(VIDEO_STREAM_CONFIG_CAPS)){
		for(int i=0; i<count; i++){
			VIDEO_STREAM_CONFIG_CAPS scc;
			AM_MEDIA_TYPE *pmt;
			ewc_hr= pConfig->GetStreamCaps(i,&pmt,reinterpret_cast<BYTE*>(&scc)); 
			if(ewc_hr==S_OK && pmt->formattype==FORMAT_VideoInfo){
				VIDEOINFOHEADER *vh= reinterpret_cast<VIDEOINFOHEADER*>(pmt->pbFormat);
				fmt[m].width= vh->bmiHeader.biWidth;
				fmt[m].height= vh->bmiHeader.biHeight;
				fmt[m].bit= vh->bmiHeader.biBitCount;
				fmt[m].AvgTimePerFrame= vh->AvgTimePerFrame;
				fmt[m].fps= 10000000./vh->AvgTimePerFrame;
				fmt[m].subtype= pmt->subtype;
				EWC_GUIDtoTEXT(fmt[m].subtype, fmt[m].subtype_t, sizeof(fmt[m].subtype_t));	//v2.3
				ewc_DeleteMediaType(pmt);
				m++;
				if(m >= *nmax) break;
			} 
		}
	}

fin_gf:
	//̍XV
	*nmax= m;
	ewc_release(pConfig);
	ewc_release(pBuilder);
	ewc_release(pCap);
	ewc_release(pGraph);

	if(ewc_cominit_gf){
		CoUninitialize();
		ewc_cominit_gf= 0;
	}
	return errcode;
}

//ΉtH[}bg擾ifoCXԍjv2.2
int EWC_GetFormat(int devn, ewc_format *fmt, int *nmax)
{
	if(devn<0 || devn>=EWC_NCAMMAX) return 1;

	return ewc_GetFormat(devn, 0, fmt, nmax);
}

//ΉtH[}bg擾ifoCXjv2.2
int EWC_GetFormat(char *devicename, ewc_format *fmt, int *nmax)
{
	return ewc_GetFormat(0, devicename, fmt, nmax);
}

//gpJnꂽJ̃foCX擾 v2.2
char *EWC_GetDeviceName(int num)
{
	if(numCheck(num)) return NULL;
	
	return ewc_s[num].dname;
}

//gpJnꂽJ̏o̓s̃fBATu^Cv擾 v2.3
char *EWC_GetDeviceSubtype(int num)
{
	if(numCheck(num)) return NULL;
	
	return ewc_s[num].dev_mstype_t;
}

//gpJnꂽJ̏o͉摜̃fBATu^Cv擾 v2.3
char *EWC_GetSubtype(int num)
{
	if(numCheck(num)) return NULL;
	
	return ewc_s[num].mstype_t;
}

const char *ewc_propstr[EWC_ITEMMAX]={
	"BRIGHTNESS","CONTRAST","HUE","SATURATION","SHARPNESS","GAMMA","COLORENABLE","WHITEBALANCE","BACKLIGHTCOMPENSATION","GAIN",
	"PAN","TILT","ROLL","ZOOM","EXPOSURE","IRIS","FOCUS"
};

//ݒt@C֕ۑ v2.4
int EWC_SaveProperty(int num, char *filename=NULL)
{
	if(numCheck(num)) return 1;

	FILE *fp;
	double val;
	int mode;
	char buf[256];

	char fname[MAX_PATH];
	if(!filename){
		//t@Cȗ̓foCX.txtg
		strcpy_s(fname,sizeof(fname),EWC_GetDeviceName(num));
		strcat_s(fname,sizeof(fname),".txt");
	}else{
		strcpy_s(fname,sizeof(fname),filename);
	}

	fopen_s(&fp,fname,"w");
	if(fp==NULL) return 2;

	for(int i=0;i<EWC_ITEMMAX;i++){
		val= EWC_GetValue(num, i, &mode);
		char ss[64];
		_gcvt_s(ss,sizeof(ss),val,18);
		if(mode){
			sprintf_s(buf,sizeof(buf),"%-21s = %s, AUTO\n",ewc_propstr[i],ss);
		}else{
			sprintf_s(buf,sizeof(buf),"%-21s = %s\n",ewc_propstr[i],ss);
		}
		fputs(buf,fp);		
	}

	fclose(fp);

	return 0;
}

//spropCԍ[0-(EWC_ITEMMAX-1)]Ԃ
//Ȃ-1Ԃ
//܂CAUTO΁Cmode=1ɂD','͏I[ɂD
int find_propstr(char *s, int size, int *mode)
{
	for(int i=0;i<EWC_ITEMMAX;i++){
		_strupr_s(s,size);
		if(strstr(s,ewc_propstr[i])){
			char *p1,*p2;
			p1=strstr(s,",");
			p2=strstr(s,"AUTO");
			if(p1 && p2){
				*mode=1;
				*p1='\0';
			}else{
				*mode=0;
			}
			return i;
		}
	}
	return -1;
}

//ݒt@Cǂݍ v2.4
int EWC_LoadProperty(int num, char *filename=NULL)
{
	if(numCheck(num)) return 1;

	FILE *fp;

	char fname[MAX_PATH];
	if(!filename){
		//t@Cȗ̓foCX.txtg
		strcpy_s(fname,sizeof(fname),EWC_GetDeviceName(num));
		strcat_s(fname,sizeof(fname),".txt");
	}else{
		strcpy_s(fname,sizeof(fname),filename);
	}

	fopen_s(&fp,fname,"r");
	if(fp==NULL) return 2;

	for(;;){
		char buf[256];
		if(fgets(buf,sizeof(buf),fp)==NULL) break;

		int mode=0;
		int i=find_propstr(buf,sizeof(buf),&mode);
		if(i<0) continue;
		
		char *p;
		p=strstr(buf,"=");
		if(!p) continue;
		p++;
		double val=atof(p);
		
		EWC_SetValue(num, i, val);
		if(mode) EWC_SetAuto(num, i);
	}

	fclose(fp);

	return 0;
}

#define ewc_YV2R(Y,V)    ((298*(Y-16)              +409*(V-128) +128)>>8)
#define ewc_YUV2G(Y,U,V) ((298*(Y-16) -100*(U-127) -208*(V-128) +128)>>8)
#define ewc_YU2B(Y,U)    ((298*(Y-16) +516*(U-127)              +128)>>8)

// NV12tH[}bgRGB32tH[}bg֕ϊ v2.7
// rgb:i[  yuv:摜  wx,wy:C[pixel]
void EWC_CnvNV12toRGB32(void* rgb, void* yuv, int wx, int wy)
{
    unsigned char* pUV= (unsigned char*)yuv +wx*wy;
	unsigned char* pY= (unsigned char*)yuv;
    unsigned char Y,U,V;
	unsigned char* pRGB= (unsigned char*)rgb;

    for(int y=0; y<wy/2; y++){
		for(int n=0; n<2; n++){
			for(int x=0; x<wx/2; x++){
				U= *pUV++;
				V= *pUV++;
				Y= *pY++;
				*pRGB++ = Limit(0, ewc_YU2B(Y,U), 255);
				*pRGB++ = Limit(0, ewc_YUV2G(Y,U,V), 255);
				*pRGB++ = Limit(0, ewc_YV2R(Y,V), 255);
				*pRGB++ = 0;
				Y = *pY++;
				*pRGB++ = Limit(0, ewc_YU2B(Y,U), 255);
				*pRGB++ = Limit(0, ewc_YUV2G(Y,U,V), 255);
				*pRGB++ = Limit(0, ewc_YV2R(Y,V), 255);
				*pRGB++ = 0;
			}
			pUV -= wx;
		}
		pUV += wx;
    }
}

// Y16tH[}bgRGB32tH[}bg֕ϊ v2.7
// iC16rbĝ8rbĝݎgj
// rgb: i[  y16:摜  wx,wy:C[pixel]
void EWC_CnvY16toRGB32(void* rgb, void* y16, int wx, int wy)
{
	unsigned short* pY= (unsigned short*)y16;
    unsigned char Y;
	unsigned char* pRGB= (unsigned char*)rgb;

    for(int y=0; y<wy; y++){
		for(int x=0; x<wx; x++){
			Y= (*pY++)>>8;
			*pRGB++ = Y;
			*pRGB++ = Y;
			*pRGB++ = Y;
			*pRGB++ = 0;
		}
    }
}

// Y800tH[}bgRGB32tH[}bg֕ϊ v2.7
// rgb: i[  y800:摜  wx,wy:C[pixel]
void EWC_CnvY800toRGB32(void* rgb, void* y800, int wx, int wy)
{
	unsigned char* pY= (unsigned char*)y800;
    unsigned char Y;
	unsigned char* pRGB= (unsigned char*)rgb;

    for(int y=0; y<wy; y++){
		for(int x=0; x<wx; x++){
			Y= *pY++;
			*pRGB++ = Y;
			*pRGB++ = Y;
			*pRGB++ = Y;
			*pRGB++ = 0;
		}
    }
}

// Oi[̂߂̍\ v2.7
struct ewc_camera{
	char FriendlyName[256];
	char Description[256];
	char DevicePath[256];
};

// J̖OƐ擾iƗŁjiEWC_Open()Ołj v2.7
int EWC_GetCameraName(ewc_camera *ewcc, int *nmax)
{
	ICreateDevEnum *pDevEnum= 0;
	IEnumMoniker *pEnum= 0;
	IMoniker *pMoniker= 0;
	int ewc_cominit_cn= 0;
	int errcode= 0;
	int n= 0;		//rfILv`foCX̃JEgp
	
	//COM̏
	if(!ewc_cominit){
		ewc_hr= CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if(ewc_hr==S_OK) ewc_cominit_cn= 1;	//tO𗧂Ă
	}

	//VXefoCX񋓎q̍쐬
	ewc_hr= CoCreateInstance(CLSID_SystemDeviceEnum,0,CLSCTX_INPROC_SERVER,IID_ICreateDevEnum,(void **)&pDevEnum);
	if(ewc_hr!=S_OK){errcode=1; goto fin_cn;}

	//񋓎q̎擾
	ewc_hr= pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory,&pEnum,0);
	if(ewc_hr!=S_OK){errcode=0; goto fin_cn;}

	//jJ̎擾
	ULONG cFetched;

	for(int i=0; i<EWC_NCAMMAX; i++){
		if(pEnum->Next(1,&pMoniker,&cFetched)==S_OK){
			
			//DisplayName̎擾
			LPOLESTR strMonikerName;
			ewc_hr= pMoniker->GetDisplayName(NULL,NULL,&strMonikerName);
			if(ewc_hr!=S_OK){errcode=3; goto fin_cn;}

			//DisplayName'@device:pnp'܂'@device:sw'
			if(wcsstr(strMonikerName,L"@device:pnp") || wcsstr(strMonikerName,L"@device:sw")){
				if(ewcc){
					IPropertyBag *pBag= 0;
					pMoniker->BindToStorage(0,0,IID_IPropertyBag,(void **)&pBag);
					VARIANT var;
					VariantInit(&var);
					var.vt= VT_BSTR;

					// FriendlyName̎擾
					pBag->Read(L"FriendlyName",&var,0);
					WideCharToMultiByte(CP_ACP,0,var.bstrVal,-1,ewcc[n].FriendlyName,sizeof(ewcc[n].FriendlyName),0,0);
					VariantClear(&var);

					// Description̎擾
					pBag->Read(L"Description",&var,0);
					WideCharToMultiByte(CP_ACP,0,var.bstrVal,-1,ewcc[n].Description,sizeof(ewcc[n].Description),0,0);
					VariantClear(&var);

					// DevicePath̎擾
					pBag->Read(L"DevicePath",&var,0);
					WideCharToMultiByte(CP_ACP,0,var.bstrVal,-1,ewcc[n].DevicePath,sizeof(ewcc[n].DevicePath),0,0);
					VariantClear(&var);

					ewc_release(pBag);
				}
				//ewccNULL̂Ƃ̓J𐔂邾
				n++;
			}
			ewc_release(pMoniker);
		}
		if(ewcc) if(n >= *nmax) break;
	}

	ewc_release(pEnum);
	ewc_release(pDevEnum);

fin_cn:
	//̍XV
	*nmax= n;

	if(ewc_cominit_cn){
		CoUninitialize();
		ewc_cominit_cn= 0;
	}
	return errcode;
}

// J䐔ԂiƗŁjiEWC_Open()Ołj v2.7
int EWC_GetCamera(void)
{
	int n;
	EWC_GetCameraName(NULL,&n);
	return n;
}

//JRaw[hgI v2.8
//rawmode= 0:㉺]iʏj@1:raw[hî܂ܓ]j
int EWC_RawMode(int num, int rawmode)
{
	if(num<0 || num>=EWC_NCAMMAX) return 1;
	ewc_raw[num]= rawmode;
	return 0;
}

//End of ewclib.h
